public class BabylonianSqrt {
	// a̕ɋ߂߂
	private static int get_x0( double a )
	{
		// a0ȉ̏ꍇAx߂
		if ( 0.0 >= a ) return (int)a;

		// ϐ̐錾
		int x0;			// i[
		double sqr0 = 0.0;	// 1Oi2i[

		// [v쐬Ai11₷
		for ( int i = 1; ; i++ ) {
			// i2̒li[
			double sqr1 = (double)( i * i );

			// sqr1aȏɂȂ
			if ( sqr1 >= a ) {
				// aɋ߂l𔻒
				if ( ( sqr1 - a ) > ( a - sqr0 ) )
					x0 = i - 1;
				else
					x0 = i;

				// [v𔲂
				break;
			}

			// POi2̒li[
			sqr0 = sqr1;
		}

		return x0;
	}


	// orjA
	private static double babylonian_method( double a )
	{
		// vZƂ݂Ȃl
		double eps = 0.0000000001;

		// a0ȉ̏ꍇAa߂
		if ( 0.0 >= a ) return a;

		// vZ̏l߂
		double x = (double)get_x0( a );

		// PǑvZʂێ
		double prev_x = x;

		// [v񐔂̏100ɂ
		for ( int i = 0; i < 1000000; i++ ) {
			// vZ
			x = ( x + a / x ) / 2.0;

			// PǑvZʂƍeps菬ꍇA[v𔲂
			if ( Math.abs( x - prev_x ) < eps ) break; 

			// PǑvZʂێ
			prev_x = x;	
		}

		// ߂
		return x;
	}


	// C
	public static void main( String[] args ) {
		for ( int i = 0; i <= 100; i++ ) {
			// ʏo
			System.out.println( i + "̕" );
			System.out.println( "orjA:" + babylonian_method( (double)i ) );
			System.out.println( "Math.SqrtŌvZ :" + Math.sqrt( (double)i ) );

			// s
			System.out.println();
		}
	}
}
